//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
void PlaceTempToForm()
{ float Temp; //     
  Temp=64*((Byte1&4)>>2)+32*((Byte1&2)>>1)+16*(Byte1&1)+8*((Byte0&128)>>7)+4*((Byte0&64)>>6)+2*((Byte0&32)>>5)+1*((Byte0&16)>>4)+0.5*((Byte0&8)>>3)+0.25*((Byte0&4)>>2)+0.125*((Byte0&2)>>1)+0.0625*(Byte0&1);

  TVarRec vr[] = {Temp};
  StringTemp=Format("%3.4f",vr,1);
  Form1->Label1->Caption=StringTemp;
}
//---------------------------------------------------------------------------
bool WriteTo()
{DWORD temp;

 WriteFile(Port,wr_buf,wr_buf_len,&temp,&ovr_wr); //   
 WaitForSingleObject(ovr_wr.hEvent,10000);        //   10         
 if(GetOverlappedResult(Port,&ovr_wr,&temp,true)) return true;  //    -  
 else                                             return false; //  - 
}
//---------------------------------------------------------------------------
bool ReadFrom()
{ COMSTAT    port_status;
  DWORD      temp, mask;
  int        Counter;

 Counter=0;
 while(Counter<100) //   100 
 { ClearCommError(Port,&temp,&port_status);    //  port_status
   rd_buf_len=0;
   rd_buf_len=port_status.cbInQue;  //-  
   if(rd_buf_len)
   { ReadFile(Port,rd_buf,rd_buf_len,&temp,&ovr_rd);  //  - 
     return true;
   }
   Counter++;
   Sleep(1);
 }
 return false;
}
//---------------------------------------------------------------------------
void OpenPort()
{ dcb.DCBlength=sizeof(DCB);
  //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  Port=CreateFile(PortName,GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,FILE_FLAG_OVERLAPPED,NULL);
  if(Port==INVALID_HANDLE_VALUE)
  { MessageBox(NULL,"  ","Error",MB_OK);
    return;
  }
  else
  { if(GetCommState(Port,&dcb)==0)
    { MessageBox(NULL,"   ","Error",MB_OK);
      CloseHandle(Port);
      Port=INVALID_HANDLE_VALUE;
      return;
    }
    else
    { dcb.BaudRate=115200;
      dcb.ByteSize=8;
      dcb.Parity=0;
      dcb.StopBits=2;
      dcb.fBinary=true;          //  
      dcb.fOutxCtsFlow=false;    //  CTS
      dcb.fOutxDsrFlow=false;    //  DSR
      dcb.fDtrControl=DTR_CONTROL_DISABLE;     // DTR
      dcb.fDsrSensitivity=false;               //  DSR
      dcb.fNull=false;           //  
      dcb.fRtsControl=RTS_CONTROL_DISABLE;    // RTS
      dcb.fAbortOnError=false;   //  /  
   }
   if(SetCommState(Port,&dcb)==0)
   { MessageBox(NULL,"   ","Error",MB_OK);
     CloseHandle(Port);
     Port=INVALID_HANDLE_VALUE;
     return;
   }

   memset(wr_buf,0,BUFSIZE);        //    
   wr_buf_len=0;                    //  
   SetupComm(Port,BUFSIZE+100,BUFSIZE+100);       //    
   PurgeComm(Port,PURGE_RXCLEAR|PURGE_TXCLEAR);   //     

   Form1->Button1->Enabled=false;
   Form1->Button2->Enabled=true;

   //  
   wr_buf_len=3;
   wr_buf[0]=0x0A;     // disable autoload
   wr_buf[1]=0x08;     // disable reports
   wr_buf[2]=0x03;     // select 1W
   if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                    ClosePort();
                    return;
                  }
  }
}
//---------------------------------------------------------------------------
void ClosePort()
{ StringTemp="No Data";
  Form1->Timer1->Enabled=false;
  Form1->Label1->Caption=StringTemp;
  CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button1->Enabled=true;
  Form1->Button2->Enabled=false;
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  StringTemp="No Data";
  Port=INVALID_HANDLE_VALUE;
  Timer1->Enabled=false;
  Button1->Enabled=true;
  Button2->Enabled=false;
  Button3->Enabled=true;
  Button4->Enabled=false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Button4Click(Sender);
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{  AboutBox->Show();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ OpenPort();
  if(Port!=INVALID_HANDLE_VALUE)
  { Timer1->Enabled=true;
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{ Timer1->Enabled=false;
  //  Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //  Skip ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;
  wr_buf[1]=0xCC;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //  Convert
  wr_buf_len=2;
  wr_buf[0]=0x61;
  wr_buf[1]=0x44;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //  1    ,    
  rd_buf[0]=0x0F;
  while(rd_buf[0]!=0x8F)
  { //   "Read Bit"
    wr_buf_len=1;
    wr_buf[0]=0x64;
    if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                     ClosePort();
                     return;
                   }
    // ,  
    if(!ReadFrom()) { MessageBox(NULL,"  ","Error",MB_OK);
                      ClosePort();
                      return;
                    }
  }
  //  2   Scratch Pad
  //  Reset
  wr_buf_len=1;
  wr_buf[0]=0x60;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  Sleep(1);
  //  Skip ROM
  wr_buf_len=2;
  wr_buf[0]=0x61;
  wr_buf[1]=0xCC;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //  Read Scratch Pad
  wr_buf_len=2;
  wr_buf[0]=0x61;
  wr_buf[1]=0xBE;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //   "Read Byte"
  wr_buf_len=1;
  wr_buf[0]=0x62;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //   
  if(!ReadFrom()) { MessageBox(NULL,"  ","Error",MB_OK);
                    ClosePort();
                    return;
                  }
  Byte0=rd_buf[0];
  //   "Read Byte"
  wr_buf_len=1;
  wr_buf[0]=0x62;
  if(!WriteTo()) { MessageBox(NULL,"  ","Error",MB_OK);
                   ClosePort();
                   return;
                 }
  //   
  if(!ReadFrom()) { MessageBox(NULL,"  ","Error",MB_OK);
                    ClosePort();
                    return;
                  }
  Byte1=rd_buf[0];
  PlaceTempToForm();
  Timer1->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ Button3->Enabled=false;
  Button4->Enabled=true;
  Edit1->ReadOnly=true;
  ServerSocket1->Port=StrToInt(Edit1->Text);
  ServerSocket1->Open();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ Button3->Enabled=true;
  Button4->Enabled=false;
  Edit1->ReadOnly=false;
  ServerSocket1->Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{ AnsiString Line, Path;
  int HTTPPos;

  //      -    Memo1
  Memo1->Clear();                    // memo1
  Memo1->Text=Socket->ReceiveText(); //      
  //    
  Line=Memo1->Lines->Strings[0];
  if(Line.Length()!=0)
  { if( Line.SubString(1,3)=="GET")
    { HTTPPos = Line.Pos("HTTP");
      Path = Line.SubString(5,HTTPPos-6);
      if(Path=="/")   //     -    
      { Socket->SendText(Memo2->Text);
      }
      else if (Path=="/?Themperature") //     -   
      { Socket->SendText("HTTP/1.0 200 OK\r\n\r\n"+StringTemp);
      }
      else Socket->SendText("HTTP/1.0 403 forbridden");
    }
  }
  Socket->Close();                //  
}
//---------------------------------------------------------------------------

